/*
 AeroQuad v3.0.1 - February 2012
 www.AeroQuad.com
 Copyright (c) 2012 Ted Carancho.  All rights reserved.
 An Open Source Arduino based multicopter.
 
 This program is free software: you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation, either version 3 of the License, or 
 (at your option) any later version. 
 
 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 GNU General Public License for more details. 
 
 You should have received a copy of the GNU General Public License 
 along with this program. If not, see <http://www.gnu.org/licenses/>. 
 
 Altered by Joao Diogo Falcao, Cornell University for ECE 4760. 
 For the Atmega644 Microcontroller.
 
 
 */


#ifndef _AEROQUAD_MOTORS_PWM_CPP_
#define _AEROQUAD_MOTORS_PWM_CPP_



#include "Motors.h"


/*volatile uint8_t atomicPWM_PIN5_lowState = 0;
 volatile uint8_t atomicPWM_PIN5_highState = 0;
 volatile uint8_t atomicPWM_PIN6_lowState = 0;
 volatile uint8_t atomicPWM_PIN6_highState = 0;
 
 void initializeSoftPWM() {
 TCCR0A = 0; // normal counting mode
 TIMSK0 |= (1<<OCIE0A); // Enable CTC interrupt
 TIMSK0 |= (1<<OCIE0B);
 }
 
 ISR(TIMER0_COMPA_vect) {
 static uint8_t state = 0;
 if (state == 0) {
 PORTD |= 1<<5; //digital PIN 5 high
 OCR0A+= atomicPWM_PIN5_highState; //250 x 4 microsecons = 1ms
 state = 1;
 } else if (state == 1) {
 OCR0A+= atomicPWM_PIN5_highState;
 state = 2;
 } else if (state == 2) {
 PORTD &= ~(1<<5); //digital PIN 5 low
 OCR0A+= atomicPWM_PIN5_lowState;
 state = 0;
 }
 }
 
 ISR(TIMER0_COMPB_vect) { //the same with digital PIN 6 and OCR0B counter
 static uint8_t state = 0;
 if (state == 0) {
 PORTD |= 1<<6;OCR0B+= atomicPWM_PIN6_highState;state = 1;
 } else if (state == 1) {
 OCR0B+= atomicPWM_PIN6_highState;state = 2;
 } else if (state == 2) {
 PORTD &= ~(1<<6);OCR0B+= atomicPWM_PIN6_lowState;state = 0;
 }
 }*/
#include "Servo.h"
#include <avr/io.h>
#include <util/delay.h>

volatile long int PWM_Period = 0;
int motor1_speed = 0;
int motor2_speed = 0;
int motor3_speed = 0;
int motor4_speed = 0;
static Servo smotor1, smotor2, smotor3, smotor4;

ISR(TIMER0_COMPA_vect){
 AbsoluteTime++; 
}
/*
 ISR(TIMER0_COMPA_vect){
 if(PWM_Period==0){
 PORTB |= (1<<PINB3);
 PORTB |= (1<<PINB4);
 PORTD |= (1<<PIND6);
 PORTD |= (1<<PIND7);
 }    
 
 if(PWM_Period > motor1_speed)
 PORTB &= ~(1<<PINB3);
 if(PWM_Period > motor2_speed)    
 PORTB &= ~(1<<PINB4);
 if(PWM_Period > motor3_speed)    
 PORTD &= ~(1<<PIND6);
 if(PWM_Period > motor4_speed)    
 PORTD &= ~(1<<PIND7);
 
 if(PWM_Period++==1605)
 PWM_Period=0;
 }*/

void initializeMotors(NB_Motors numbers) {
    numberOfMotors = numbers;
    
    /*MOTORPORT0 |= (1<<MOTORPIN0);  //pinMode(MOTORPIN0, OUTPUT);
    MOTORPORT1 |= (1<<MOTORPIN1);  //pinMode(MOTORPIN1, OUTPUT);
    MOTORPORT2 |= (1<<MOTORPIN2);  //pinMode(MOTORPIN2, OUTPUT);
    MOTORPORT3 |= (1<<MOTORPIN3);  //pinMode(MOTORPIN3, OUTPUT);
    
    set up timer 0 for 1 mSec ticks
     TIMSK0 = 2;		//turn on timer 0 cmp match ISR 
     OCR0A = 79;  	//set the compare reg to 250 time ticks
     TCCR0A = 0b00000010; // turn on clear-on-match
     TCCR0B = 0b00000001;	// clock prescalar to 64
     
     sei();*/
    smotor1.attach(3);
    smotor2.attach(4);
    smotor3.attach(5);
    smotor4.attach(6);


    
    commandAllMotors(1000);
    
}

void writeMotors() {
    smotor1.write(motorCommand[MOTOR1]);
    smotor2.write(motorCommand[MOTOR2]);
    smotor3.write(motorCommand[MOTOR3]);
    smotor4.write(motorCommand[MOTOR4]);
    
}

void commandAllMotors(int command) {
    smotor1.write(command);
    smotor2.write(command);
    smotor3.write(command);
    smotor4.write(command);
}  


#endif
